/****************************************************************************/
/*   Dinaminio steko C++ pavyzdys panaudojant klase.                        */
/*   DStack clase ir jos funkciju prototipai yra deklaruoti dstack.h.       */
/*   Panaudojimas demonstruojamas tdstack.cpp                               */
/****************************************************************************/
#include<iostream.h>
#include "dstack.h"

DStack::DStack(int N)               // inicializuojame N elementu steka
{                                   
   bottom_ = new float[N];
   top_ = bottom_;
   size_ = N;
}

DStack::~DStack()                   // lokali atmintis
{                                    
   delete [] bottom_;
}

int DStack::num_items() const       // elementu esanciu siuo metu steke skaicius
{
    return (top_ - bottom_ );
}

void DStack::push(float val)        // naujos reiksmes ikelimas 
{
    *top_ = val; 
    top_++;
}

float DStack::pop()                 // ismetimas e;emento nuo steko virsaus
{
    top_--;
    return *top_;
}


int DStack::full() const            // 1 jei pilas stekas, 0 priesingu atveju
{
    return (num_items() >= size_);
}


int DStack::empty() const           // 1 jei tuscias, 0 priesingu atveju
{   
    return (num_items() <= 0);
}



void DStack::print() const
{

      cout << "Stack currently holds " << num_items() << " items: " ;        
      for (float *element=bottom_; element<top_; element++)
      {
          cout << "  " << *element;
      }
      cout << "\n";
    
}
    


